﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CellularAutomata
{
    //automate célulaire propriété d'une case/cellule ? on ratache juste ce type de propriété à une cellule pour qu'elle 
    //prenne le comporte d'automate cellulaire?
    /// <summary>
    /// Rule : la règle qui sera appliquée aux cellules de la structure
    /// CellStructure : la structure de donnée dans laquelle les cellules seront stockées : matrice, elements reliés par pointeurs etc
    /// </summary>
    public interface IAutomaton
    {
        IRule Rule
        {
            get;
            set;
        }

        IStructure CellStructure
        {
            get;
            set;
        }

        void Update();
        void Update(double time);
    }
}
