﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using CellularAutomata;
using Maths.Vectors;

namespace GameOfLife
{
    public class Automaton:IAutomaton, IDrawable
    {

        List<Cell> _cells;

        public List<Cell> Cells
        {
            get { return _cells; }
            set { _cells = value; }
        }

        public Automaton()
        {
            _cells = new List<Cell>();
        }

        public Automaton(int size)
        {
            _cells = new List<Cell>();
            for (int i = 0; i < size; i++)
            {
                for (int j = 0; j < size; j++)
                {         
                    _cells.Add(new Cell(new Vector(j*20,i*20,0)));
                }

            }

            for (int i = 1; i < size * size - 1; i++)
            {
                _cells[i].NeighBours.Add(_cells[i + 1]);
                _cells[i].NeighBours.Add(_cells[i - 1]);
            }
            /*
            for (int i = 1; i < size-1; i++)
            {
                for (int j = 1; j < size-1; j++)
                {
                    _cells[i].NeighBours.Add(_cells[i + 1]);
                    _cells[i].NeighBours.Add(_cells[i - 1]);
                    _cells[i].NeighBours.Add(_cells[size + i + 1]);
                    _cells[i].NeighBours.Add(_cells[size + i - 1]);
                }

            }*/
        }

        #region IAutomaton Members

        public IRule Rule
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public IStructure CellStructure
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public void Update()
        {
            for (int i = 0; i < _cells.Count; i++)
            {
                _cells[i].update();
            }
        }

        public void Update(double time)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region IDrawable Members

        public void draw(System.Drawing.Graphics g)
        {
            for (int i = 0; i < _cells.Count; i++)
            {
                _cells[i].draw(g);
            }
        }

        #endregion
    }
}
