﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using CellularAutomata;
using System.Drawing;
using Maths.Vectors;

namespace GameOfLife
{
    public class Cell:IDataCell<bool>, IDrawable
    {
        bool _data;
        bool dataDuplicate;

        List<ICell> _neighBours;
        int _pass;
        Vector _position;

        public Cell(Vector position)
        {
            _data = false;
            dataDuplicate = false;
            _neighBours = new List<ICell>();
            _pass = 0;
            _position = position;
        }

        public Cell():this(new Vector())
        {}



        #region IDataCell<bool> Members

        public bool Data
        {
            get
            {
                return _data;
            }
            set
            {
                _data=value;
            }
        }

        #endregion

        #region ICell Members

        public List<ICell> NeighBours
        {
            get
            {
                return _neighBours;
            }
            set
            {
                _neighBours=value;
            }
        }

        public void update()
        {
            int liveNeighBours = 0;
            for (int i = 0; i < NeighBours.Count; i++)
            {
                if (((Cell)NeighBours[i]).Data)
                {

                    liveNeighBours++;
                }
            }

            if(Data)
            {
                liveNeighBours++;
            }
              
             if (_pass == 0)
            {
                dataDuplicate = Data;
                if (liveNeighBours == 3)
                {
                    if (dataDuplicate == false)
                    {
                        dataDuplicate = true;
                    }
                }
                else if (liveNeighBours == 2 || liveNeighBours == 3)
                {
                    //dataDuplicate = true;
                }
                else
                {
                    dataDuplicate = false;
                }
                _pass = 1;
            }
            else
            {
                _data = dataDuplicate;
                _pass = 0;
            }
        }

        #endregion

        #region IDrawable Members

        public void draw(Graphics g)
        {
            if (_data)
            {
                //g.DrawRectangle(new Pen(Brushes.White), (float)_position.X, (float)_position.Y, 20, 20);
                g.FillRectangle(Brushes.White, (float)_position.X, (float)_position.Y, 20, 20);
            }
            else
            {
                //g.DrawRectangle(new Pen(Brushes.Black), (float)_position.X, (float)_position.Y, 20, 20);
                g.FillRectangle(Brushes.Black, (float)_position.X, (float)_position.Y, 20, 20);
            }
        }

        #endregion
    }
}
