using System;
using System.Collections.Generic;
using System.Text;

namespace Environment.CellTypes
{
    public class PhysicsCell:ICell
    {

        Material _material;
        List<ICell> _neighbours;
        bool _isEmiter;

        public Material Material
        {
            get { return _material; }
            set { _material = value; }
        }
        public bool IsEmiter
        {
            get { return _isEmiter; }
            set { _isEmiter = value; }
        }

        public PhysicsCell()
        {
            _material = new Material(-5);
            _neighbours = new List<ICell>();
            _isEmiter = false;
        }

        public void update()
        {
            foreach (PhysicsCell neighbour in Neigbours)
            {
                float tempDif = this.Material.Heat - neighbour.Material.Heat;
             //   
             //  
                /* tempDif=clamp(tempDif, -neighbour.Material.Heat / 8, this.Material.Heat / 8);

                 if (!_isEmiter)
                 {
                     this.Material.NewHeat -= tempDif / 2 - 5.5f;
                 }

                 if (!neighbour.IsEmiter)
                 {
                     //neighbour.Material.Heat += tempDif / 2 - 5.5f;
                     neighbour.Material.NewHeat += tempDif / 2 - 5.5f;
                 }*/
                
                if (!_isEmiter)
                {
                    this.Material.Heat -= tempDif / 2 - 5.5f;
                   // this.Material.NewHeat -= tempDif / 2 - 5.5f;
                }

                if (!neighbour.IsEmiter)
                {
                    neighbour.Material.Heat += tempDif / 2 - 5.5f;
                  // neighbour.Material.NewHeat += tempDif / 2 - 5.5f; ;
                }
            }
        }

        public float clamp(float value, float min, float max)
        {
            if (value < min)
            {
                return min;
            }
            if (value > max)
            {
                return max;
            }
            return value;
        }

        public void increase_heat(float value)
        {
            _material.Heat += value;
        }
        public void decrease_heat(float value)
        {
            _material.Heat -= value;
        }

        #region ICell Members

        public List<ICell> Neigbours
        {
            get
            {
                return _neighbours;
            }
            set
            {
                _neighbours = value;
            }
        }

        public void Set_Neighbours(List<ICell> cells)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void Add_Neighbour(ICell cell)
        {
            _neighbours.Add(cell);
        }
        #endregion
    }
}
