using System;
using System.Collections.Generic;
using System.Text;

namespace Environment
{

    public enum State { Alive, Dead };

    public class TestCell : ICell
    {
        State _state;
        List<ICell> _neighbours;
        public TestCell()
        {
            _state = State.Dead;
            _neighbours = new List<ICell>();
        }

        public State State
        {
            get { return _state; }
            set { _state = value; }
        }

        #region ICell Members

        public List<ICell> Neigbours
        {
            get
            {
                return _neighbours;
            }
            set
            {
                _neighbours=value;
            }
        }

        public void Set_Neighbours(List<ICell> cells)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void Add_Neighbour(ICell cell)
        {
            _neighbours.Add(cell);
        }

        #endregion
    }

    public class TestEnv:Grid<TestCell>
    {

        public void randomize()
        {
            Random r = new Random();
           
            for (int i = 0; i < Height; i++)
            {
                for (int j = 0; j < Width; j++)
                {
                    int val = r.Next(0, 3);
                    if (val == 0)
                    {
                        this[i, j].State = State.Alive;
                    }
                }


            }

        }

        public TestEnv(int width, int height)
            : base(width, height)
        {
  
        }

        public void update()
        {
            Grid<TestCell> _buffer = new Grid<TestCell>(Width, Height);

            for (int i = 0; i < Height; i++)
            {
                for (int j = 0; j < Width; j++)
                {
                    TestCell current = this[i, j]; 
                    int liveNeighbours=0;
                    foreach (TestCell neighbour in current.Neigbours)
                    {
                        if (neighbour.State == State.Alive)
                        {
                            liveNeighbours++;
                        }
                    }
                 
                    _buffer[i, j].State = changeState(current.State, liveNeighbours);
                }
            }
            this.Cells = _buffer.Cells;
        }

        public State changeState(State currentState, int liveNeighbours)
        {
            State state = currentState;
            if (currentState == State.Alive)
            {
                if (liveNeighbours <= 1)
                {
                    state = State.Dead;
                    return state;

                }
                if (liveNeighbours >= 4)//rsultats trs interessants avec 5
                {
                    state = State.Dead;
                    return state;
                }
                if (liveNeighbours == 2 || liveNeighbours == 3)
                {
                    state = State.Alive;
                    return state;
                }
            }
            else
            {
                if (liveNeighbours == 3)
                {
                    state = State.Alive;
                    return state;
                }

            }
            return state;
        }
    }
}
