using System;
using System.Collections.Generic;
using System.Text;

namespace Environment.CellTypes
{
    public class PhysicsCell:ICell
    {

        Material _material;
        List<ICell> _neighbours;

        public Material Material
        {
            get { return _material; }
            set { _material = value; }
        }

        public PhysicsCell()
        {
            _material = new Material(-99);
            _neighbours = new List<ICell>();
        }

        public void update()
        {
            foreach (PhysicsCell neighbour in Neigbours)
            {
                float tempDif = this.Material.Heat - neighbour.Material.Heat;
                this.Material.NewHeat -= tempDif /2;
                neighbour.Material.Heat += tempDif / 2;
            }
        }

        public void increase_heat(float value)
        {
            _material.Heat += value;
        }
        public void decrease_heat(float value)
        {
            _material.Heat -= value;
        }

        #region ICell Members

        public List<ICell> Neigbours
        {
            get
            {
                return _neighbours;
            }
            set
            {
                _neighbours = value;
            }
        }

        public void Set_Neighbours(List<ICell> cells)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void Add_Neighbour(ICell cell)
        {
            _neighbours.Add(cell);
        }
        #endregion
    }
}
